import java.io.*;
import java.text.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import javax.naming.*;
import javax.rmi.*;
import javax.mail.*;
import javax.mail.internet.*;

public class ListManageServlet extends HttpServlet {

    private Context ctx;
    private MailListHome home;
    private PrintWriter out;

    public ListManageServlet() throws NamingException
    {
	try {
	    ctx = new InitialContext();
	    home = (MailListHome) PortableRemoteObject.narrow(ctx.lookup("MailList"),
								 MailListHome.class);
	} catch (Exception e) { }
    }

    public void doGet(HttpServletRequest request,
                      HttpServletResponse response)
        throws IOException, ServletException
    {
        response.setContentType("text/html");
        out = response.getWriter();

        out.println("<html>");
        out.println("<head>");
        out.println("<title>Mailing List Manager</title>");
        out.println("</head>");
        out.println("<body bgcolor=\"white\">");

        out.println("<h1> Email List: </h1>");

	// first, see if there is an address to remove

        String remove = request.getParameter("remove");
        if ( remove != null)
	{
            try
	    {
		home.remove(remove);
	    }
            catch (Exception e) { out.println(e.toString()); }
	}

	// print the list, along with "remove" links
	
	try 
	{
	    Collection co = home.findAll();
	    Iterator it = co.iterator();
	    
	    while (it.hasNext())
	    {
		MailList ml = (MailList) it.next();
		out.println("email: " + ml.getEmail() );
		out.println("<a href=\"/MailList/Manage?remove=" + ml.getEmail() + "\">remove</a><br>");
	    }
	}
	catch(Exception e)
	{
	    out.println(e.toString());
	}

	// now display the "add" form

	out.println("<form action=\"/MailList/Manage\" method=\"post\">");
	out.println("<input type=\"text\" name=\"email\">");
	out.println("<input type=\"submit\" value=\"add\">");
    } 


    public void doPost(HttpServletRequest request,
		       HttpServletResponse response)
	throws IOException, ServletException
    {
	response.setContentType("text/html");
	PrintWriter out = response.getWriter();
	
	out.println("<html>");
	out.println("<head>");
	out.println("<title>Mailing List Manager</title>");
	out.println("</head>");
	out.println("<body bgcolor=\"white\">");

	// add a new list member

	String email = request.getParameter("email");
	if ( email != "" && email != null)
	{
	    try 
	    {
		MailList ml = home.create(email);
		out.println("Added, thank you. <a href=\"/MailList/Manage\">Start again</a>.");
	    } 
	    catch (Exception e) { out.println(e.toString()); }
	}
	else
	{
	    out.println("Please specify email address.");
	}
	out.println("</body>");
	out.println("</html>");
    }

}





