import java.io.*;
import java.text.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import javax.naming.*;
import javax.rmi.*;
import javax.mail.*;
import javax.mail.internet.*;

public class SendServlet extends HttpServlet {

    private Context ctx;
    private MailListHome home;
    private PrintWriter out;
    private Session session;

    public SendServlet() throws NamingException
    {
	///////// set this to your local SMTP server.  
	///////// note: "localhost" won't work on OS X unless you've already configured sendmail

	String mailHost = "localhost";

	//Get system properties
	Properties props = System.getProperties();
	
	//Specify the SMTP server
	props.put("mail.smtp.host", mailHost);
	
	// create a new Session object
	this.session = Session.getInstance(props,null);
    }

    public void doGet(HttpServletRequest request,
                      HttpServletResponse response)
        throws IOException, ServletException
    {
        response.setContentType("text/html");
        out = response.getWriter();

        out.println("<html>");
        out.println("<head>");
        out.println("<title>Send to Mailing List</title>");
        out.println("</head>");
        out.println("<body bgcolor=\"white\">");

	// display the mail form

        out.println("<h1> Create Message </h1>");
	out.println("<form action=\"/MailList/Send\" method=\"POST\">");
	out.println("Mail From: <input type=\"text\" name=\"from\">");
	out.println("<br>Subject: <input type=\"text\" name=\"subject\">");
	out.println("<br>Message:<br><textarea name=\"message\" rows=\"10\" cols=\"40\"></textarea>");
	out.println("<br><input type=\"submit\" value=\"Send\">");
	out.println("</form>");
	out.println("</body></html");
    } 


    public void doPost(HttpServletRequest request,
		       HttpServletResponse response)
	throws IOException, ServletException
    {
	response.setContentType("text/html");
	out = response.getWriter();
	
	out.println("<html>");
	out.println("<head>");
	out.println("<title>Sending Message</title>");
	out.println("</head>");
	out.println("<body bgcolor=\"white\">");

	// send mail to all users

	String message = request.getParameter("message");
	String from = request.getParameter("from");
	String subject = request.getParameter("subject");
	int count = 0;
	try 
        {
	    ctx = new InitialContext();
	    home = (MailListHome) PortableRemoteObject.narrow(ctx.lookup("MailList"),
								 MailListHome.class);
	    Collection co = home.findAll();
	    Iterator it = co.iterator();
	    
	    while (it.hasNext())
	    {
		MailList ml = (MailList) it.next();
		if (sendMessage(message, subject, ml.getEmail(), from ))
		{
		    count++;
		}
	    }
	    out.println("Sent " + count + " messages.  Thank you.");
	}
	catch(Exception e)
	{
	    out.println(e.toString());
	}

    }

    boolean sendMessage(String mess, String subject, String email, String from)
    {
	try 
	{
	    // create a new MimeMessage object (using the Session created in the constructor)
	    Message message = new MimeMessage(this.session);
	    message.setFrom(new InternetAddress(from));
	    message.setRecipients(Message.RecipientType.TO, new InternetAddress[] { new InternetAddress(email) });
	    message.setSubject(subject);
	    message.setContent(mess, "text/plain");
	    
	    Transport.send(message);
	    return true;
	} 
	catch (Exception e) 
	{ 
	    out.println(e.toString()); 
	    return false;
	}
	
    }
}





